#include "testlib.h"
#include <iostream>
#include <cassert>
#include <vector>

using namespace std;

int my_rand(int l, int r, int wnext = 0) {
    assert(l <= r);
    if (l == r)
        return l;
    return rnd.wnext(r - l + 1, wnext) + l;
}

const int MAX_C = 1'000'000'000;

const int maxn = 2e5 + 228;

vector<int> g[maxn];
int p[maxn];
int cnt = 0;

void dfs(int v, int p = -1, int num = -1) {
    int cur = ++cnt;
    if (cur > 1)
        ::p[cur] = num;
    for (int i: g[v]) {
        if (i != p)
            dfs(i, v, cur);
    }
}

void build_random_p(int n, int wnext_p) {
    vector<int> pruffers_code(n - 2);
    for (int i = 0; i < n - 2; i++) {
        pruffers_code[i] = my_rand(1, n, wnext_p);
    }
    map<int, int> cnt;
    for (int i = 0; i < n - 2; i++) {
        cnt[pruffers_code[i]]++;
    }
    set<int> nums;
    for (int i = 1; i <= n; i++) {
        nums.insert(i);
    }
    for (int i = 0; i < n - 2; i++) {
        nums.erase(pruffers_code[i]);
    }
    for (int i = 0; i < n - 2; i++) {
        g[*nums.begin()].push_back(pruffers_code[i]);
        g[pruffers_code[i]].push_back(*nums.begin());
        nums.erase(nums.begin());
        cnt[pruffers_code[i]]--;
        if (cnt[pruffers_code[i]] == 0) {
            nums.insert(pruffers_code[i]);
        }
    }
    int a = *nums.begin();
    int b = *(++nums.begin());
    g[a].push_back(b);
    g[b].push_back(a);
    dfs(1);
}


int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    int mode = opt<int>("mode");

    int n = opt<int>("n");
    int q = opt<int>("q");
    int max_k = opt<int>("max_k");
    int percent = opt<int>("percent");
    int max_t = opt<int>("max_t");
    int bamboo = opt<int>("bamboo");
    int binary = opt<int>("binary");
    int wnext_p = opt<int>("wnext_p");

    build_random_p(n, wnext_p);

    if (mode == 1) {
        cout << n << " " << q << endl;
        vector<int> candidates;
        for (int i = 2; i <= n; i++) {
            if (i % 2 == 0) {
                cout << i - 1 << " \n"[i == n];
                candidates.push_back(i);
            } else {
                cout << i - 2 << " \n"[i == n];
            }
        }
        for (int i = 1; i <= n; i++) {
            cout << my_rand(1, max_t) << " \n"[i == n];
        }
        for (int i = 1; i <= n; i++) {
            if (i == 1) {
                cout << MAX_C * 3ll / 7 << " \n"[i == n];
            } else {
                cout << my_rand(1, MAX_C) << " \n"[i == n];
            }
        }
        for (int i = 1; i <= q; i++) {
            if (my_rand(1, 100) <= percent) {
                cout << "1 " << my_rand(1, n) << " " << my_rand(1, 2) << endl;
            } else {
                if (i <= q / 2) {
                    cout << "2 ";
                    cout << my_rand(1, max_t) << " ";
                    cout << 2 << " ";
                    for (int j = 0; j < 2; j++) {
                        swap(candidates[j], candidates[my_rand(j, candidates.size() - 1)]);
                        cout << candidates[j] << " \n"[j == 1];
                    }
                } else {
                    cout << "2 ";
                    cout << my_rand(1, max_t) << " ";
                    cout << "2 2 " << my_rand(1, (n - 2) / 2) * 2 + 2 << endl;
                }
            }
        }
    } else if (mode == 2) {
        cout << n << " " << q << endl;
        for (int i = 2; i <= n; i++) {
            cout << i / 2 << " \n"[i == n];
        }
        vector<int> t(n + 1);
        int max_t = 0;
        for (int i = 1; i <= n; i++) {
            t[i] = t[i / 2] + 1;
            max_t = max(max_t, t[i]);
            cout << t[i] << " \n"[i == n];
        }
        for (int i = 1; i <= n; i++)
            cout << my_rand(1, MAX_C) << " \n"[i == n];
        vector<int> nums(n);
        for (int i = 0; i < n; i++)
            nums[i] = i + 1;
        for (int i = 0; i < q; i++) {
            if (my_rand(1, 100) <= percent) {
                cout << "1 " << my_rand(1, n) << " 1" << endl;
            } else {
                cout << "2 " << my_rand(1, max_t) << " ";
                int k = my_rand(1, max_k);
                cout << k << " ";
                for (int j = 0; j < k; j++) {
                    swap(nums[j], nums[my_rand(j, n - 1)]);
                    cout << nums[j] << " \n"[j == k - 1];
                }
            }
        }
    } else if (mode == 3) {
        cout << n << " " << q << endl;
        if (bamboo && binary) {
            cout << "failed state" << endl;
            return 0;
        }
        for (int i = 2; i <= n; i++) {
            if (bamboo) {
                cout << i - 1 << " \n"[i == n];
            } else if (binary) {
                cout << i / 2 << " \n"[i == n];
            } else {
                cout << p[i] << " \n"[i == n];
            }
        }
        for (int i = 1; i <= n; i++) {
            cout << 1 << " \n"[i == n];
        }
        for (int i = 1; i <= n; i++) {
            cout << my_rand(1, MAX_C) << " \n"[i == n];
        }
        vector<int> nums(n), nums2(n);
        for (int i = 0; i < n; i++)
            nums[i] = i + 1, nums2[i] = i + 1;
        int cnt = 0;
        for (int i = 1; i <= q; i++) {
            if (my_rand(1, 100) <= percent) {
                cout << "1 ";
                swap(nums[cnt], nums[my_rand(cnt, n - 1)]);
                cout << nums[cnt] << " 2" << endl;
                cnt++;
            } else {
                int k = my_rand(1, max_k);
                cout << "2 2 " << k << " ";
                for (int j = 0; j < k; j++) {
                    swap(nums[j], nums[my_rand(j, n - 1)]);
                    cout << nums[j] << " \n"[j == k - 1];
                }
            }
        }
    } else if (mode == 4) {
        cout << n << " " << q << endl;
        for (int i = 2; i <= n; i++)
            cout << i - 1 << " \n"[i == n];
        for (int i = 1; i <= n; i++)
            cout << i << " \n"[i == n];
        for (int i = 1; i <= n; i++)
            cout << my_rand(1, MAX_C) << " \n"[i == n];
        for (int i = 1; i <= q; i++) {
            int a = my_rand(1, n), b = my_rand(1, n);
            if (a > b)
                swap(a, b);
            cout << "2 " << a << " 1 " << b << endl;
        }
    }
}
