#include "testlib.h"
#include <iostream>
#include <cassert>
#include <vector>

using namespace std;

int my_rand(int l, int r, int wnext = 0) {
    assert(l <= r);
    if (l == r)
        return l;
    return rnd.wnext(r - l + 1, wnext) + l;
}

const int maxn = 2e5 + 228;

vector<int> g[maxn];
int p[maxn * 2];
int true_p[maxn];
int cnt = 0;

void dfs(int v, int p = -1, int num = -1) {
    int cur = ++cnt;
    if (cur > 1)
        ::p[cur] = num;
    for (int i: g[v]) {
        if (i != p)
            dfs(i, v, cur);
    }
}

void build_random_p(int n, int wnext_p, int tail) {
    vector<int> pruffers_code(n - 2);
    for (int i = 0; i < n - 2; i++) {
        pruffers_code[i] = my_rand(1, n, wnext_p);
    }
    map<int, int> cnt;
    for (int i = 0; i < n - 2; i++) {
        cnt[pruffers_code[i]]++;
    }
    set<int> nums;
    for (int i = 1; i <= n; i++) {
        nums.insert(i);
    }
    for (int i = 0; i < n - 2; i++) {
        nums.erase(pruffers_code[i]);
    }
    for (int i = 0; i < n - 2; i++) {
        g[*nums.begin()].push_back(pruffers_code[i]);
        g[pruffers_code[i]].push_back(*nums.begin());
        nums.erase(nums.begin());
        cnt[pruffers_code[i]]--;
        if (cnt[pruffers_code[i]] == 0) {
            nums.insert(pruffers_code[i]);
        }
    }
    int a = *nums.begin();
    int b = *(++nums.begin());
    g[a].push_back(b);
    g[b].push_back(a);
    dfs(1);
    for (int i = 2; i <= n; i++) {
        if (i <= tail) {
            true_p[i] = i - 1;
        } else {
            true_p[i] = p[i - tail] + tail;
        }
    }
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    int n = opt<int>("n");
    int q = opt<int>("q");
    int max_k = opt<int>("max_k");
    int bamboo = opt<int>("bamboo", 0);
    int binary = opt<int>("binary", 0);
    int type_is_2 = opt<int>("type_is_2", 0);
    int t_is_1 = opt<int>("t_is_1", 0);
    int max_t = opt<int>("max_t", n);
    int max_c = opt<int>("max_c", 1'000'000'000);
    int percent = opt<int>("percent_of_first_type", 20);
    int wnext_p = opt<int>("wnext_p", 0);
    int wnext_c = opt<int>("wnext_c", 0);
    int wnext_t = opt<int>("wnext_t", 0);
    int tail = opt<int>("tail", n / 10);

    vector<int> nums(n);
    for (int i = 0; i < n; i++) {
        nums[i] = i + 1;
    }

    cout << n << " " << q << endl;

    if (binary && bamboo) {
        cout << "failed state" << endl;
        return 0;
    }
    if (bamboo) {
        for (int i = 2; i <= n; i++) {
            cout << i - 1 << " \n"[i == n];
        }
    } else if (binary) {
        for (int i = 2; i <= n; i++) {
            cout << i / 2 << " \n"[i == n];
        }
    } else {
        build_random_p(n, wnext_p, tail);
        for (int i = 2; i <= n; i++) {
            cout << true_p[i] << " \n"[i == n];
        }
    }
    for (int i = 1; i <= n; i++) {
        if (t_is_1) {
            cout << 1 << " \n"[i == n];
        } else {
            cout << my_rand(1, max_t, wnext_t) << " \n"[i == n];
        }
    }
    for (int i = 1; i <= n; i++)
        cout << my_rand(1, max_c, wnext_c) << " \n"[i == n];
    for (int i = 0; i < q; i++) {
        if (my_rand(1, 100) <= percent) {
            if (type_is_2) {
                cout << "failed state" << endl;
                return 0;
            }
            cout << 1 << " ";
            cout << my_rand(1, n) << " " << my_rand(1, max_t, wnext_t) << '\n';
        } else {
            cout << 2 << " ";
            cout << my_rand(1, max_t) << " ";
            int cur_k = my_rand(1, max_k);
            cout << cur_k << " ";
            for (int j = 0; j < cur_k; j++) {
                swap(nums[j], nums[my_rand(j, n - 1)]);
                cout << nums[j] << " \n"[j == cur_k - 1];
            }
        }
    }
}
